USE [COWS]
GO
_CreateObject 'SP','dbo','updateBARTask'
GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
-- =============================================
-- Author:		<Ramesh Ragi>
-- Create date: <11/02/2011>
-- Description:	<This stored procedure is used to 
--	insert BAR (Bill Activation Ready) task or 
--	update hold status on BAR task>
-- =============================================
ALTER PROCEDURE dbo.updateBARTask
	@ORDR_ID	INT,
	@TaskId		SMALLINT = 0,
	@TaskStatus	TINYINT = 0,
	@Comments	Varchar(100) = ''		
AS
BEGIN
SET NOCOUNT ON;

BEGIN TRY
DECLARE @WG_PTRN_ID INT
DECLARE @WG_PROF_ID INT
SET @WG_PTRN_ID = 0
SET @WG_PROF_ID = 0
	IF EXISTS
		(
			SELECT 'X'
				FROM	dbo.ACT_TASK WITH (NOLOCK)
				WHERE	ORDR_ID =	@ORDR_ID
					AND	TASK_ID	=	1000
					AND	STUS_ID	=	3
		)
		BEGIN
			UPDATE		dbo.ACT_TASK WITH (ROWLOCK)
				SET		STUS_ID	=	0, MODFD_DT = GETDATE()
				WHERE	ORDR_ID =	@ORDR_ID
					AND	TASK_ID	=	1000
					AND	STUS_ID	=	3
		END
	ELSE
		BEGIN
			SELECT	@WG_PTRN_ID = ISNULL(wpt.WG_PTRN_ID,0)
					,@WG_PROF_ID = ISNULL(wpf.WG_PROF_ID,0)
				FROM	dbo.ORDR		o	WITH (NOLOCK)
			INNER JOIN	dbo.LK_PPRT		lp 	WITH (NOLOCK)	ON	lp.PPRT_ID		=	o.PPRT_ID
			INNER JOIN	dbo.SM			sm	WITH (NOLOCK)	ON	sm.SM_ID		=	lp.SM_ID
			INNER JOIN	dbo.WG_PTRN_SM	wpt	WITH (NOLOCK)	ON	wpt.WG_PTRN_ID	=	sm.PRE_REQST_WG_PTRN_ID
			INNER JOIN	dbo.WG_PROF_SM	wpf	WITH (NOLOCK)	ON	wpf.WG_PROF_ID	=	wpt.PRE_REQST_WG_PROF_ID
				WHERE	o.ORDR_ID = @ORDR_ID
					AND wpf.PRE_REQST_TASK_ID	=	1000 
				
				
			IF @WG_PROF_ID <> 0 AND @WG_PTRN_ID <> 0
				BEGIN
					DELETE FROM dbo.WG_PTRN_STUS WITH (ROWLOCK)	WHERE ORDR_ID = @ORDR_ID AND WG_PTRN_ID = @WG_PTRN_ID
					DELETE FROM dbo.WG_PROF_STUS WITH (ROWLOCK)	WHERE ORDR_ID = @ORDR_ID AND WG_PTRN_ID = @WG_PTRN_ID
					DELETE FROM dbo.ACT_TASK	WITH (ROWLOCK)	WHERE ORDR_ID = @ORDR_ID AND WG_PROF_ID = @WG_PROF_ID
					
					INSERT INTO WG_PTRN_STUS (ORDR_ID,WG_PTRN_ID,STUS_ID,CREAT_DT)
					VALUES (@ORDR_ID,@WG_PTRN_ID,0,GETDATE())
					
					INSERT INTO WG_PROF_STUS (ORDR_ID,WG_PROF_ID,WG_PTRN_ID,STUS_ID,CREAT_DT)
					VALUES (@ORDR_ID,@WG_PROF_ID,@WG_PTRN_ID,0,GETDATE())
					
					INSERT INTO ACT_TASK(ORDR_ID,TASK_ID,STUS_ID,WG_PROF_ID,CREAT_DT)
					VALUES (@ORDR_ID,1000,0,@WG_PROF_ID,GETDATE())	
				END	
			
		END

	--IF ISNULL((SELECT TOP 1 ORDR_TYPE_CD FROM dbo.FSA_ORDR WITH (NOLOCK) WHERE ORDR_ID = @ORDR_ID), '') = 'CH'
	--BEGIN
	--	EXEC dbo.LoadxNCICustomerTurnUpTask @ORDR_ID
	--END

END TRY
BEGIN CATCH
	EXEC [dbo].[insertErrorInfo]
END CATCH
END

GO
